/*!
 * fine-mq v0.1.0
 * (c) 2018-present Honoré Nintunze <nintu.lab@gmail.com>
 * Released under the MIT License.
 */
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var hyphenize = function hyphenize(str) {
  return str.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
};

var o2mq = function o2mq(queryObject) {
  if (typeof queryObject === 'string' || !queryObject) return queryObject;
  return Object.entries(queryObject).reduce(function (mq, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        feature = _ref2[0],
        value = _ref2[1];

    feature = hyphenize(feature);

    if (typeof value === 'boolean') {
      mq.push(value ? "".concat(feature) : "not ".concat(feature));
    } else {
      var isDimension = /[height|width]$/.test(feature) && Number.isFinite(+value);
      mq.push("(".concat(feature, ": ").concat(isDimension ? +value + 'px' : value, ")"));
    }

    return mq;
  }, []).join(' and ');
};

var toMqString = function toMqString(query) {
  return (Array.isArray(query) ? query : [query]).map(function (q) {
    return o2mq(q);
  }).join(', ');
};

export default toMqString;
